"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModalViewModule = void 0;
var _reactNative = require("react-native");
var Helpers = _interopRequireWildcard(require("./functions/helpers"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const moduleName = "RNIModalViewModule";
const NativeModule = _reactNative.NativeModules[moduleName];
const COMMAND_KEYS = {
  dismissModalByID: 'dismissModalByID',
  dismissAllModals: 'dismissAllModals'
};

// wip
const ModalViewFocusEvents = new _reactNative.NativeEventEmitter(NativeModule);
class ModalViewModule {
  static dismissModalByID() {
    let modalID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    const promise = new Promise((resolve, reject) => {
      try {
        NativeModule[COMMAND_KEYS.dismissModalByID](modalID, success => {
          (success ? resolve : reject)();
        });
      } catch (error) {
        console.log("ModalViewModule, dismissModalByID error:");
        console.log(error);
        reject(error);
      }
      ;
    });
    return Helpers.promiseWithTimeout(1000, promise);
  }
  static dismissAllModals() {
    let animated = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
    const promise = new Promise((resolve, reject) => {
      try {
        NativeModule[COMMAND_KEYS.dismissAllModals](animated, success => {
          (success ? resolve : reject)();
        });
      } catch (error) {
        console.log("ModalViewModule, dismissAllModals error:");
        console.log(error);
        reject();
      }
      ;
    });
    return Helpers.promiseWithTimeout(1000, promise);
  }
}
exports.ModalViewModule = ModalViewModule;
;
//# sourceMappingURL=ModalViewModule.js.map