function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import React from 'react';
import { ModalContext } from '../context/ModalContext';
import { ModalEventKeys } from '../constants/Enums';
const eventKeys = Object.keys(ModalEventKeys);
export function withModalLifecycle(WrappedComponent) {
  var _class;
  return _class = class extends React.PureComponent {
    constructor() {
      super(...arguments);
      _defineProperty(this, "_handleChildRef", node => {
        const {
          ref
        } = this.props;

        // store a copy of the child comp ref
        this.childRef = node;
        if (typeof ref === 'function') {
          ref(node);
        } else if (ref) {
          ref.current = node;
        }
        ;
      });
    }
    componentDidMount() {
      const modalContext = this.context;
      const modalEmitter = modalContext.getEmitterRef();
      for (const eventKey of eventKeys) {
        const functionName = `handle-${eventKey}`;
        this[functionName] = event => {
          var _this$childRef, _this$childRef$onModa;
          (_this$childRef = this.childRef) === null || _this$childRef === void 0 ? void 0 : (_this$childRef$onModa = _this$childRef.onModalShow) === null || _this$childRef$onModa === void 0 ? void 0 : _this$childRef$onModa.call(_this$childRef, event);
        };
        modalEmitter.addListener(eventKey, this[functionName]);
      }
      ;
    }
    componentWillUnmount() {
      const modalContext = this.context;
      const modalEmitter = modalContext.getEmitterRef();
      for (const eventKey of eventKeys) {
        const functionName = `handle-${eventKey}`;
        modalEmitter.removeListener(eventKey, this[functionName]);
      }
      ;
    }
    render() {
      const props = this.props;
      return /*#__PURE__*/React.createElement(WrappedComponent, _extends({}, props, {
        ref: this._handleChildRef
      }));
    }
  }, _defineProperty(_class, "contextType", ModalContext), _class;
}
;
//# sourceMappingURL=withModalLifecycle.js.map